%%% post analysis for option MAX and MEAN
%%% 07/07/2010

cntfigall = 1;
%%% Multidimensional Scaling Analysis
if flagmds == 1
    mindim = min([dimmdsfrom dimmds2from]);
    maxdim = max([dimmdsto dimmds2to]);

    fid_mds = fopen([foldername '/Output_MDS_Fechnerian.txt'],'wt');
    fid_mdss = fopen([foldername '/Output_MDS_Sindex.txt'],'wt');
    testdate = clock;   % [year month day hour minute second]
    fprintf(fid_mds,' *** Created : %d/%d/%d %d:%d:%0.0f \n',testdate([2 3 1 4 5 6]));
    fprintf(fid_mds,'\n****** Multidimensional Scaling ******\n');
    fprintf(fid_mds,'Input Data = Fechnerian Distances : Dimension %d to %d',dimmdsfrom,dimmdsto);

    fprintf(fid_mdss,' *** Created : %d/%d/%d %d:%d:%0.0f \n',testdate([2 3 1 4 5 6]));
    fprintf(fid_mdss,'\n****** Multidimensional Scaling ******\n');
    fprintf(fid_mdss,'Input Data = S-index : Dimension %d to %d ',dimmds2from,dimmds2to);

    stressall = zeros(dimmdsto-dimmdsfrom+1,1);     % stress values for MDS-Fechnerian
    stressall2 = zeros(dimmds2to-dimmds2from+1,1);  % stress values for MDS-Sindex
    Gmdsall = [];   % all MDS results for Fechnerian
    Smdsall = [];   % all MDS results for S-index

    screeplot_flag = 0; % generate scree plot if selected dimension is more than 1 in both Fech, S-index data
    if dimmdsto-dimmdsfrom > 0 || dimmds2to-dimmds2from > 0
        screeplot_flag = 1;
    end

    for dimmds = mindim:maxdim

        dimmds2 = dimmds;

        if dimmds >= dimmdsfrom && dimmds <= dimmdsto
            fprintf(fid_mds,'\n\n=== Dimension %d ===\n\n',dimmds);
        end
        if dimmds >= dimmds2from && dimmds <= dimmds2to
            fprintf(fid_mdss,'\n\n=== Dimension %d ===\n\n',dimmds);
        end

        Gsq = squareform(G);
        Ssq = squareform(S);

        switch startmds
            case 1
                opt_start = 'cmdscale';
            case 2
                opt_start = 'random';
        end
        switch displaymds
            case 1
                opt_display = 'off';
                fprintf(fid_mds,'  ''Display'' is ''off''\n');
            case 2
                opt_display = 'iter';
            case 3
                opt_display = 'final';
        end
        opts = statset('Display',opt_display,'MaxIter',maxitermds,'TolFun',tolfunmds,'TolX',tolxmds);
        switch methodmds
            case 1
                if nonmetricmds == 1
                    [Gmds,stress,disparities,Tinfomds,chkErrormds] = mdscale2(Gsq,dimmds,fid_mds,'criterion','stress','Start', ...
                        opt_start,'Replicates',repmds,'Options',opts);
                    opt_method = 'non-metric stress';
                elseif nonmetricmds == 2
                    [Gmds,stress,disparities,Tinfomds,chkErrormds] = mdscale2(Gsq,dimmds,fid_mds,'criterion','sstress','Start', ...
                        opt_start,'Replicates',repmds,'Options',opts);
                    opt_method = 'non-metric squared stress';
                end
            case 2
                if metricmds == 1
                    [Gmds,stress,disparities,Tinfomds,chkErrormds] = mdscale2(Gsq,dimmds,fid_mds,'criterion','metricstress','Start', ...
                        opt_start,'Replicates',repmds,'Options',opts);
                    opt_method = 'metric stress';
                elseif metricmds == 2
                    [Gmds,stress,disparities,Tinfomds,chkErrormds] = mdscale2(Gsq,dimmds,fid_mds,'criterion','metricsstress','Start', ...
                        opt_start,'Replicates',repmds,'Options',opts);
                    opt_method = 'metric squared stress';
                elseif metricmds == 3
                    [Gmds,stress,disparities,Tinfomds,chkErrormds] = mdscale2(Gsq,dimmds,fid_mds,'criterion','sammon','Start', ...
                        opt_start,'Replicates',repmds,'Options',opts);
                    opt_method = 'metric sammon';
                elseif metricmds == 4
                    [Gmds,stress,disparities,Tinfomds,chkErrormds] = mdscale2(Gsq,dimmds,fid_mds,'criterion','strain','Start', ...
                        opt_start,'Replicates',repmds,'Options',opts);
                    opt_method = 'metric strain';
                end
        end

        if dimmds == dimmdsto
            Gmds4km = Gmds;              % G of max. dimension from MDS for KMEANS
        end

        switch startmds2
            case 1
                opt_start2 = 'cmdscale';
            case 2
                opt_start2 = 'random';
        end
        switch displaymds2
            case 1
                opt_display2 = 'off';
                fprintf(fid_mdss,'  ''Display'' is ''off''\n');
            case 2
                opt_display2 = 'iter';
            case 3
                opt_display2 = 'final';
        end
        opts2 = statset('Display',opt_display2,'MaxIter',maxitermds2,'TolFun',tolfunmds2,'TolX',tolxmds2);
        switch methodmds2
            case 1
                if nonmetricmds2 == 1
                    [Smds,stress2,disparities2,Tinfomds2,chkErrormds2] = mdscale2(Ssq,dimmds,fid_mdss,'criterion','stress','Start', ...
                        opt_start2,'Replicates',repmds2,'Options',opts2);
                    opt_method2 = 'non-metric stress';
                elseif nonmetricmds2 == 2
                    [Smds,stress2,disparities2,Tinfomds2,chkErrormds2] = mdscale2(Ssq,dimmds,fid_mdss,'criterion','sstress','Start', ...
                        opt_start2,'Replicates',repmds2,'Options',opts2);
                    opt_method2 = 'non-metric squared stress';
                end
            case 2
                if metricmds2 == 1
                    [Smds,stress2,disparities2,Tinfomds2,chkErrormds2] = mdscale2(Ssq,dimmds,fid_mdss,'criterion','metricstress','Start', ...
                        opt_start2,'Replicates',repmds2,'Options',opts2);
                    opt_method2 = 'metric stress';
                elseif metricmds2 == 2
                    [Smds,stress2,disparities2,Tinfomds2,chkErrormds2] = mdscale2(Ssq,dimmds,fid_mdss,'criterion','metricsstress','Start', ...
                        opt_start2,'Replicates',repmds2,'Options',opts2);
                    opt_method2 = 'metric squared stress';
                elseif metricmds2 == 3
                    [Smds,stress2,disparities2,Tinfomds2,chkErrormds2] = mdscale2(Ssq,dimmds,fid_mdss,'criterion','sammon','Start', ...
                        opt_start2,'Replicates',repmds2,'Options',opts2);
                    opt_method2 = 'metric sammon';
                elseif metricmds2 == 4
                    [Smds,stress2,disparities2,Tinfomds2,chkErrormds2] = mdscale2(Ssq,dimmds,fid_mdss,'criterion','strain','Start', ...
                        opt_start2,'Replicates',repmds2,'Options',opts2);
                    opt_method2 = 'metric strain';
                end
        end

        if dimmds == dimmds2to
            Smds4km = Smds;
        end

        if chkErrormds == 0 && chkErrormds2 == 0

            figure(cntfigall); clf(cntfigall);
            if dimmds >= dimmdsfrom && dimmds <= dimmdsto   % Fechnerian
                stressall(dimmds-dimmdsfrom+1,1) = stress;
                Gmdsall = [Gmdsall Gmds];
                %                     figure(cntfigall); clf(cntfigall);
                if dimmds >= dimmdsfrom && dimmds >= dimmds2from && dimmds <= dimmdsto && dimmds <= dimmds2to
                    subplot(2,2,1);
                end
                hold on;
                if methodmds == 2
                    distances = pdist(Gmds);
                    plot(Gsq,distances,'bo', ...
                        [0 max(Gsq)],[0 max(Gsq)],'k:');
                    xlabel('Fechnerian Distances'); ylabel('Euclidean Distances')
                else
                    distances = pdist(Gmds);
                    [dum,ord] = sortrows([disparities(:) Gsq(:)]);
                    plot(Gsq,distances,'bo', ...
                        Gsq(ord),disparities(ord),'r.-');
                    xlabel('Fechnerian Distances'); ylabel('Euclidean Distances')
                    legend({'Distances' 'Disparities'},'Location','NW');
                end
                hold off; axis equal;
                titletext = ['MDS - Fechnerian vs Euclidean : Dim.' num2str(dimmds)];
                title(titletext);
            end

            if dimmds >= dimmds2from && dimmds <= dimmds2to    % S-index
                stressall2(dimmds-dimmds2from+1,1) = stress2;
                Smdsall = [Smdsall Smds];

                if dimmds >= dimmdsfrom && dimmds >= dimmds2from && dimmds <= dimmdsto && dimmds <= dimmds2to
                    subplot(2,2,2);
                end
                hold on;
                if methodmds2 == 2
                    distances2 = pdist(Smds);
                    plot(Ssq,distances2,'bo', ...
                        [0 max(Ssq)],[0 max(Ssq)],'k:');
                    xlabel('S-index'); ylabel('Euclidean Distances')
                else
                    distances2 = pdist(Smds);
                    [dum,ord] = sortrows([disparities2(:) Ssq(:)]);
                    plot(Ssq,distances2,'bo', ...
                        Ssq(ord),disparities2(ord),'r.-');
                    xlabel('S-index'); ylabel('Euclidean Distances')
                    legend({'Distances' 'Disparities'},'Location','NW');
                end
                hold off; axis equal;
                titletext = ['MDS - S-index vs Euclidean : Dim.' num2str(dimmds)];
                title(titletext);
            end

            if dimmds >= dimmdsfrom && dimmds >= dimmds2from && dimmds <= dimmdsto && dimmds <= dimmds2to
                subplot(2,2,[3 4]); hold on;
                plot(distances,distances2,'bo');
                xlabel('MDS-Fechnerian Distances');
                ylabel('MDS-S-index');
                hold off; axis equal;
                xmax = max(distances);
                ymax = max(distances2);
                axis([0 xmax 0 ymax]);
                titletext = ['MDS - Fechnerian vs S-index : Dim.' num2str(dimmds)];
                title(titletext);
                %                     FIG_out = ['../' foldername '/Fig' num2str(cntfigall) '_MDS_Fechnerian_vs_S_dim' num2str(dimmds)];
                %                     FIG_out = ['../' foldername '/Figure_MDS_Fechnerian_vs_S_dim' num2str(dimmds)];
                FIG_out = [foldername '/Figure_MDS_Fechnerian_vs_S_dim' num2str(dimmds)];
                saveas(gcf,FIG_out);
                %                     print('-f','-djpeg','-r300',FIG_out);
            end
            if screeplot_flag == 0
                cntfigall = cntfigall+1;
            end

            %%% Use Fechnerian Distance G
            if dimmds >= dimmdsfrom && dimmds <= dimmdsto
                if dimmds >= 1 && dimmds <= 9
                    figure(cntfigall); clf(cntfigall); hold on;

                    maxsubplot = 4;
                    cntfig = 1;
                    cnt = 1;

                    if dimmds == 1  % only plot dimension n = 1
                        figure(cntfigall); clf(cntfigall);
                        plot(1:length(Gmds),Gmds,'o','linewidth',1);
                        toff_x = 0.25;
                        toff_y = (max(Gmds)-min(Gmds))/30;
                        text((1:length(Gmds))+toff_x,Gmds-toff_y,char(ptid),'fontsize',9);
                        xmin = 1;
                        xmax = length(Gmds);
                        ymin = min(Gmds);
                        ymax = max(Gmds);
                        if ymin == ymax
                            ymin = ymin-0.01;
                            ymax = ymax+0.01;
                        end
                        axis([xmin xmax ymin ymax]);
                        xtext = 'Dimension 1';
                        xlabel(xtext);
                        ytext = '';
                        ylabel(ytext);
                        title(['MDS Solution : Fechnerian - Dim.' num2str(dimmds)]);
                        axis equal; hold off;
                    end

                    for i = 1:dimmds-1
                        for j = i+1:dimmds

                            if mod(cnt,maxsubplot) == 1
                                merge = 0;
                                cnt = 1;
                                cntfig = cntfig+1;
                                if cntfig ~= 2
                                    %                             FIG_out = ['files_cab\MDS Scatter Plot ' num2str(cntfig-2)];
                                    %                                         FIG_out = ['../' foldername '/Fig' num2str(cntfigall) '_MDS_Fechnerian_dim' num2str(dimmds)];
                                    %                                         FIG_out = ['../' foldername '/Figure_MDS_Fechnerian_dim' num2str(dimmds)];
                                    if dimmds > 3
                                        FIG_out = [foldername '/Figure_MDS_Fechnerian_dim' num2str(dimmds) '_' num2str(cntfig-2)];
                                    else
                                        FIG_out = [foldername '/Figure_MDS_Fechnerian_dim' num2str(dimmds)];
                                    end
                                    saveas(gcf,FIG_out);
                                    %                                         print('-f','-djpeg','-r300',FIG_out);
                                    if screeplot_flag == 0
                                        cntfigall = cntfigall+1;
                                    end
                                end
                                figure(cntfigall); clf(cntfigall);
                                maxrow = 2;
                                maxcol = 2;
                                toff_x = (max(Gmds(:,i))-min(Gmds(:,i)))/30;
                                toff_y = (max(Gmds(:,j))-min(Gmds(:,j)))/30;
                                if (dimmds*(dimmds-1)/2-(cntfig-2)*maxsubplot) == 1
                                    maxrow = 1;
                                    maxcol = 1;
                                    toff_x = (max(Gmds(:,i))-min(Gmds(:,i)))/60;
                                    toff_y = (max(Gmds(:,j))-min(Gmds(:,j)))/60;
                                elseif (dimmds*(dimmds-1)/2-(cntfig-2)*maxsubplot) == 2
                                    maxrow = 2;
                                    maxcol = 1;
                                elseif (dimmds*(dimmds-1)/2-(cntfig-2)*maxsubplot) == 3
                                    maxrow = 2;
                                    maxcol = 2;
                                    merge = 1;
                                    %                     elseif (dimmds*(dimmds-1)/2-(cntfig-2)*maxsubplot) < 4
                                    %                         maxrow = ceil((dimmds*(dimmds-1)/2-(cntfig-2)*maxsubplot)/maxcol);
                                end
                                %                         title('MDS (Fechnerian Distances) Scatter Plot');
                            end
                            if merge == 1 && cnt == 3
                                subplot(maxrow,maxcol,cnt:cnt+1);
                                %                         title(['MDS
                                %                         Solution : Fechnerian Dim.' num2str(i) ' vs Dim.' num2str(j)]);
                                title(['MDS Solution : Fechnerian - Dim.' num2str(dimmds)]);
                            else
                                subplot(maxrow,maxcol,cnt);
                                %                         title(['MDS Solution : Fechnerian Dim.' num2str(i) ' vs Dim.' num2str(j)]);
                                title(['MDS Solution : Fechnerian - Dim.' num2str(dimmds)]);
                            end
                            hold on;
                            plot(Gmds(:,i),Gmds(:,j),'o','linewidth',1);
                            %                 toff_x = (max(Gmds(:,i))-min(Gmds(:,i)))/30;
                            %                 toff_y = (max(Gmds(:,j))-min(Gmds(:,j)))/30;
                            text(Gmds(:,i)+toff_x,Gmds(:,j)-toff_y,char(ptid),'fontsize',9);
                            xmin = min(Gmds(:,i));
                            xmax = max(Gmds(:,i));
                            ymin = min(Gmds(:,j));
                            ymax = max(Gmds(:,j));
                            if xmin == xmax
                                xmin = xmin-0.01;
                                xmax = xmax+0.01;
                            end
                            if ymin == ymax
                                ymin = ymin-0.01;
                                ymax = ymax+0.01;
                            end
                            axis([xmin xmax ymin ymax]);
                            xtext = ['Dimension ' num2str(i)];
                            xlabel(xtext);
                            ytext = ['Dimension ' num2str(j)];
                            ylabel(ytext);
                            axis equal; hold off;
                            cnt = cnt+1;

                        end
                    end
                    %                         FIG_out = ['../' foldername '/Fig' num2str(cntfigall) '_MDS_Fechnerian_dim' num2str(dimmds)];
                    %                         FIG_out = ['../' foldername '/Figure_MDS_Fechnerian_dim' num2str(dimmds)];
                    if dimmds > 3
                        if cnt ~= 1
                            FIG_out = [foldername '/Figure_MDS_Fechnerian_dim' num2str(dimmds) '_' num2str(cntfig-1)];
                        end
                    else
                        FIG_out = [foldername '/Figure_MDS_Fechnerian_dim' num2str(dimmds)];
                    end
                    saveas(gcf,FIG_out);
                    %                         print('-f','-djpeg','-r300',FIG_out);
                    if screeplot_flag == 0
                        cntfigall = cntfigall+1;
                    end
                end
            end
            %                 G = squareform(G);
            %                 fclose(fid_mds);

            %%% Use Input Matrix - S
            if dimmds >= dimmds2from && dimmds <= dimmds2to
                if dimmds2 >= 1 && dimmds2 <= 9
                    figure(cntfigall); clf(cntfigall); hold on;
                    maxsubplot = 4;
                    cntfig = 1;
                    cnt = 1;

                    if dimmds2 == 1  % only plot dimension n = 1
                        figure(cntfigall); clf(cntfigall);
                        plot(1:length(Smds),Smds,'o','linewidth',1);
                        toff_x = 0.25;
                        toff_y = (max(Smds)-min(Smds))/30;
                        text((1:length(Smds))+toff_x,Smds-toff_y,char(ptid),'fontsize',9);
                        xmin = 1;
                        xmax = length(Smds);
                        ymin = min(Smds);
                        ymax = max(Smds);
                        if ymin == ymax
                            ymin = ymin-0.01;
                            ymax = ymax+0.01;
                        end
                        axis([xmin xmax ymin ymax]);
                        xtext = 'Dimension 1';
                        xlabel(xtext);
                        ytext = '';
                        ylabel(ytext);
                        title(['MDS Solution : S-index - Dim.' num2str(dimmds)]);
                        axis equal; hold off;
                    end

                    for i = 1:dimmds2-1
                        for j = i+1:dimmds2

                            if mod(cnt,maxsubplot) == 1
                                merge = 0;
                                cnt = 1;
                                cntfig = cntfig+1;
                                if cntfig ~= 2
                                    %                         AlterWindow(['Figure ' num2str(cntfig-1)],'maximize');
                                    %                             FIG_out = ['files_cab\MDS S Scatter Plot ' num2str(cntfig-2)];
                                    %                                         FIG_out = ['../' foldername '/Fig' num2str(cntfigall) '_MDS_Sindex_dim' num2str(dimmds)];
                                    %                                         FIG_out = ['../' foldername '/Figure_MDS_Sindex_dim' num2str(dimmds)];
                                    if dimmds2 > 3
                                        FIG_out = [foldername '/Figure_MDS_Sindex_dim' num2str(dimmds2) '_' num2str(cntfig-2)];
                                    else
                                        FIG_out = [foldername '/Figure_MDS_Sindex_dim' num2str(dimmds2)];
                                    end
                                    saveas(gcf,FIG_out);
                                    %                                         print('-f','-djpeg','-r300',FIG_out);
                                    if screeplot_flag == 0
                                        cntfigall = cntfigall+1;
                                    end
                                end
                                figure(cntfigall); clf(cntfigall);
                                maxrow = 2;
                                maxcol = 2;
                                toff_x = (max(Smds(:,i))-min(Smds(:,i)))/30;
                                toff_y = (max(Smds(:,j))-min(Smds(:,j)))/30;
                                if (dimmds2*(dimmds2-1)/2-(cntfig-2)*maxsubplot) == 1
                                    maxrow = 1;
                                    maxcol = 1;
                                    toff_x = (max(Smds(:,i))-min(Smds(:,i)))/60;
                                    toff_y = (max(Smds(:,j))-min(Smds(:,j)))/60;
                                elseif (dimmds2*(dimmds2-1)/2-(cntfig-2)*maxsubplot) == 2
                                    maxrow = 2;
                                    maxcol = 1;
                                elseif (dimmds2*(dimmds2-1)/2-(cntfig-2)*maxsubplot) == 3
                                    maxrow = 2;
                                    maxcol = 2;
                                    merge = 1;
                                    %                     elseif (dimmds*(dimmds-1)/2-(cntfig-2)*maxsubplot) < 4
                                    %                         maxrow = ceil((dimmds*(dimmds-1)/2-(cntfig-2)*maxsubplot)/maxcol);
                                end
                                %                         title('MDS (S-index) Scatter Plot');
                            end
                            if merge == 1 && cnt == 3
                                subplot(maxrow,maxcol,cnt:cnt+1);
                                title(['MDS Solution : S-index - Dim.' num2str(dimmds)]);
                            else
                                subplot(maxrow,maxcol,cnt);
                                title(['MDS Solution : S-index - Dim.' num2str(dimmds)]);
                            end
                            hold on;
                            plot(Smds(:,i),Smds(:,j),'o','linewidth',1);
                            %                toff_x = (max(Smds(:,i))-min(Smds(:,i)))/30;
                            %                toff_y = (max(Smds(:,j))-min(Smds(:,j)))/30;
                            text(Smds(:,i)+toff_x,Smds(:,j)-toff_y,char(ptid),'fontsize',9);
                            xmin = min(Smds(:,i));
                            xmax = max(Smds(:,i));
                            ymin = min(Smds(:,j));
                            ymax = max(Smds(:,j));
                            if xmin == xmax
                                xmin = xmin-0.01;
                                xmax = xmax+0.01;
                            end
                            if ymin == ymax
                                ymin = ymin-0.01;
                                ymax = ymax+0.01;
                            end
                            axis([xmin xmax ymin ymax]);
                            xtext = ['Dimension ' num2str(i)];
                            xlabel(xtext);
                            ytext = ['Dimension ' num2str(j)];
                            ylabel(ytext);
                            axis equal; hold off;
                            cnt = cnt+1;

                        end
                    end
                    %             FIG_out = ['files_cab\MDS S Scatter Plot ' num2str(cntfig-1)];
                    %                         FIG_out = ['../' foldername '/Fig' num2str(cntfigall) '_MDS_Sindex_dim' num2str(dimmds)];
                    %                         FIG_out = ['../' foldername '/Figure_MDS_Sindex_dim' num2str(dimmds)];
                    if dimmds2 > 3
                        if cnt ~= 1
                            FIG_out = [foldername '/Figure_MDS_Sindex_dim' num2str(dimmds2) '_' num2str(cntfig-1)];
                        end
                    else
                        FIG_out = [foldername '/Figure_MDS_Sindex_dim' num2str(dimmds2)];
                    end
                    saveas(gcf,FIG_out);
                    %                         print('-f','-djpeg','-r300',FIG_out);
                    if screeplot_flag == 0
                        cntfigall = cntfigall+1;
                    end
                end
            end
            %                 S = squareform(S);
            %                 fclose(fid_mdss);
        else
            flagmds = 0;
            Tinfo = [Tinfomds; Tinfomds2];
            disp(' *** Error in MDS *** ');
            disp(Tinfo);
            disp('');

            fprintf(fid_mds,' \n *** Error in MDS ***\n');
            fprintf(fid_mdss,' \n *** Error in MDS ***\n');

        end

        if gui_active
            h_pbar = progressbar( h_pbar,1/max_count); % update progressbar
        else
            T = {sprintf('\nOperation was aborted by user')} ;
            set(handles.info, 'String',T);    % Show text T (information)
            progressbar( h_pbar,-1 );          % finish progress bar
            break ;
        end
    end
    fclose(fid_mds);
    fclose(fid_mdss);

    if flagmds == 1     % if there is no error in MDS
        %% generate a scree plot
        if dimmdsto-dimmdsfrom > 0 || dimmds2to-dimmds2from > 0
            figure(cntfigall); clf(cntfigall);
            subplot(1,2,1); hold on;
            plot(dimmdsfrom:dimmdsto,stressall,'b-o');
            xlabel('Dimension'); ylabel('Stress');
            stressall_max = max(stressall);
            stressall_min = min(stressall);
            %             axis([1 length(stressall) stressall_min-0.1*(stressall_max-stressall_min) stressall_max+0.1*(stressall_max-stressall_min)]);
            axis([1 9 0 stressall_max+0.1*(stressall_max-stressall_min)]);
            %                 set(gca,'Xtick',1:length(stressall));
            %                 set(gca,'Xticklabel',dimmdsfrom:dimmdsto);
            set(gca,'Xtick',1:9);
            set(gca,'Xticklabel',1:9);
            title('Scree Plot : Fechnerian');

            subplot(1,2,2); hold on;
            plot(dimmds2from:dimmds2to,stressall2,'b-o');
            xlabel('Dimension'); ylabel('Stress');
            stressall2_max = max(stressall2);
            stressall2_min = min(stressall2);
            %             axis([1 length(stressall2) stressall2_min-0.1*(stressall2_max-stressall2_min) ...
            %                 stressall2_max+0.1*(stressall2_max-stressall2_min)]);
            axis([1 9 0 ...
                stressall2_max+0.1*(stressall2_max-stressall2_min)]);
            %                 set(gca,'Xtick',1:length(stressall2));
            %                 set(gca,'Xticklabel',dimmds2from:dimmds2to);
            set(gca,'Xtick',1:9);
            set(gca,'Xticklabel',1:9);
            title('Scree Plot : S-index');
            cntfigall = cntfigall+1;

            %                 FIG_out = ['../' foldername '/Figure_MDS_Scree_Plot'];
            FIG_out = [foldername '/Figure_MDS_Scree_Plot'];
            saveas(gcf,FIG_out);
            %                 print('-f','-djpeg','-r300',FIG_out);
        end
    end
end

%%% KMEANS analysis
Idkm = 0;
Idkms = 0;
if flagkm == 1 & chkErrormds == 0 & chkErrormds2 == 0
    %     fid_km = fopen('files_cab\Output_km.txt','wt');      % UNIX use 'w', PC use 'wt'
    %         fid_km = fopen(['../' foldername '/Output_KMEANS_Fechnerian.txt'],'wt');
    fid_km = fopen([foldername '/Output_KMEANS_Fechnerian.txt'],'wt');
    testdate = clock;   % [year month day hour minute second]
    fprintf(fid_km,' *** Created : %d/%d/%d %d:%d:%0.0f \n',testdate([2 3 1 4 5 6]));
    fprintf(fid_km,'\n****** KMEANS Analysis ******\n');
    fprintf(fid_km,' Input Data = Fechnerian Distances\n\n');
    %     fid_kms = fopen('files_cab\Output_kms.txt','wt');      % UNIX use 'w', PC use 'wt'
    %         fid_kms = fopen(['../' foldername '/Output_KMEANS_Sindex.txt'],'wt');
    fid_kms = fopen([foldername '/Output_KMEANS_Sindex.txt'],'wt');
    fprintf(fid_kms,' *** Created : %d/%d/%d %d:%d:%0.0f \n',testdate([2 3 1 4 5 6]));
    fprintf(fid_kms,'\n****** KMEANS Analysis ******\n');
    fprintf(fid_kms,' Input Data = S-index Distances\n\n');
    switch emptykm
        case 1
            opt_empty = 'error';
        case 2
            opt_empty = 'drop';
        case 3
            opt_empty = 'singleton';
    end
    switch startkm
        case 1
            opt_startkm = 'sample';
        case 2
            opt_startkm = 'uniform';
        case 3
            opt_startkm = 'cluster';
    end
    switch displaykm
        case 1
            opt_displaykm = 'off';
            fprintf(fid_km,' ''Display'' is ''off''\n');
            fprintf(fid_kms,' ''Display'' is ''off''\n');
        case 2
            opt_displaykm = 'iter';
        case 3
            opt_displaykm = 'final';
    end
    %     opts = statset('Display',opt_displaykm,'MaxIter',maxiterkm,'TolFun',tolfunkm,'TolX',tolxkm);
    [Idkm,Gkm,sumdkm,Dkm,Tinfokm,chkErrorkm] = kmeans2(fid_km,Gmds4km,cluskm,'emptyaction',opt_empty, ...
        'replicates',repkm,'start',opt_startkm,'maxiter',maxiterkm,'display',opt_displaykm);
    [Idkms,Gkms,sumdkms,Dkms,Tinfokm2,chkErrorkm2] = kmeans2(fid_kms,Smds4km,cluskm,'emptyaction',opt_empty, ...
        'replicates',repkm,'start',opt_startkm,'maxiter',maxiterkm,'display',opt_displaykm);

    if chkErrorkm == 0 & chkErrorkm2 == 0
        figure(cntfigall); clf(cntfigall);
        subplot(1,2,1); hold on;
        [silh,h] = silhouette(Gmds,Idkm);
        set(get(gca,'Children'),'FaceColor',[.8 .8 1]);
        xlabel('Silhouette Value');
        ylabel('Cluster');
        title('Silhouette Plot : Fechnerian Distances');
        hold off;

        subplot(1,2,2); hold on;
        [silh,h] = silhouette(Smds,Idkms);
        set(get(gca,'Children'),'FaceColor',[.8 .8 1]);
        xlabel('Silhouette Value');
        ylabel('Cluster');
        title('Silhouette Plot : S-index');
        hold off;
        %             FIG_out = ['../' foldername '/Fig' num2str(cntfigall) '_KMEANS_Silhouette'];
        %             FIG_out = ['../' foldername '/Figure_KMEANS_Silhouette'];
        FIG_out = [foldername '/Figure_KMEANS_Silhouette'];
        saveas(gcf,FIG_out);
        %             print('-f','-djpeg','-r300',FIG_out);
        cntfigall = cntfigall+1;

        clustercolor = {'ro','go','bo','ko','co',...
            'r^','g^','b^','k^','c^',...
            'r+','g+','b+','k+','c+',...
            'rs','gs','bs','ks','cs'};
        centroidcolor = {'r','g','b','k','c'};

        if dimmdsto == 2
            figure(cntfigall); clf(cntfigall);
            if dimmds2to == 2 || dimmds2to == 3
                subplot(1,2,1);
            end
            hold on;
            toff_x = (max(Gmds(:,1))-min(Gmds(:,1)))/60;
            toff_y = (max(Gmds(:,2))-min(Gmds(:,2)))/60;
            h = 0;
            textlegend = {};
            for i = 1:cluskm
                h(i) = plot(Gmds(Idkm==i,1),Gmds(Idkm==i,2),clustercolor{i},'markersize',6,'linewidth',2);
                h(i+cluskm) = plot(Gkm(i,1),Gkm(i,2),[centroidcolor{ceil(mod(i,5.001))} 'x'],'markersize',10,'linewidth',2);
                plot(Gkm(i,1),Gkm(i,2),[centroidcolor{ceil(mod(i,5.001))} 'o'],'markersize',10,'linewidth',2);
                text(Gmds(Idkm==i,1)+toff_x,Gmds(Idkm==i,2)-toff_y,char(ptid(Idkm==i)),'fontsize',9,'color',...
                    centroidcolor{ceil(mod(i,5.001))});
                textlegend{i} = ['Cluster ' num2str(i)];
            end
            textlegend{i+1} = 'Centroids';
            legend(h(1:cluskm+1),textlegend);
            xlabel('Dimension 1'); ylabel('Dimension 2');
            axis equal;
            hold off;
            title('KMEANS : Fechnerian Distances');

            if dimmds2to ~= 2 && dimmds2to ~= 3
                cntfigall = cntfigall+1;
            end
        elseif dimmdsto == 3
            figure(cntfigall); clf(cntfigall);
            if dimmds2to == 2 || dimmds2to == 3
                subplot(1,2,1);
            end
            hold on;
            toff_x = (max(Gmds(:,1))-min(Gmds(:,1)))/30;
            toff_y = (max(Gmds(:,2))-min(Gmds(:,2)))/30;
            toff_z = (max(Gmds(:,3))-min(Gmds(:,3)))/30;
            h = 0;
            textlegend = {};
            for i = 1:cluskm
                h(i) = plot3(Gmds(Idkm==i,1),Gmds(Idkm==i,2),Gmds(Idkm==i,3),clustercolor{i},'markersize',6,'linewidth',2);
                h(i+cluskm) = plot3(Gkm(i,1),Gkm(i,2),Gkm(i,3),[centroidcolor{ceil(mod(i,5.001))} 'x'],'markersize',10,'linewidth',2);
                plot3(Gkm(i,1),Gkm(i,2),Gkm(i,3),[centroidcolor{ceil(mod(i,5.001))} 'o'],'markersize',10,'linewidth',2);
                text(Gmds(Idkm==i,1)+toff_x,Gmds(Idkm==i,2)-toff_y,Gmds(Idkm==i,3)-toff_z,char(ptid(Idkm==i)),'fontsize',9,'color',...
                    centroidcolor{ceil(mod(i,5.001))});
                textlegend{i} = ['Cluster ' num2str(i)];
            end
            textlegend{i+1} = 'Centroids';
            legend(h(1:cluskm+1),textlegend);
            xlabel('Dimension 1'); ylabel('Dimension 2'); zlabel('Dimension 3');
            box on; grid on;
            view(35,15);
            axis equal;
            hold off;
            title('KMEANS : Fechnerian Distances');

            if dimmds2to ~= 2 && dimmds2to ~= 3
                cntfigall = cntfigall+1;
            end
        end
        fclose(fid_km);

        if dimmds2to == 2
            if dimmdsto ~= 2 && dimmdsto ~= 3
                figure(cntfigall); clf(cntfigall);
            else
                subplot(1,2,2);
            end
            hold on;
            toff_x = (max(Smds(:,1))-min(Smds(:,1)))/60;
            toff_y = (max(Smds(:,2))-min(Smds(:,2)))/60;
            h = 0;
            textlegend = {};
            for i = 1:cluskm
                h(i) = plot(Smds(Idkms==i,1),Smds(Idkms==i,2),clustercolor{i},'markersize',6,'linewidth',2);
                h(i+cluskm) = plot(Gkms(i,1),Gkms(i,2),[centroidcolor{ceil(mod(i,5.001))} 'x'],'markersize',10,'linewidth',2);
                plot(Gkms(i,1),Gkms(i,2),[centroidcolor{ceil(mod(i,5.001))} 'o'],'markersize',10,'linewidth',2);
                text(Smds(Idkms==i,1)+toff_x,Smds(Idkms==i,2)-toff_y,char(ptid(Idkms==i)),'fontsize',9,'color',...
                    centroidcolor{ceil(mod(i,5.001))});
                textlegend{i} = ['Cluster ' num2str(i)];
            end
            textlegend{i+1} = 'Centroids';
            legend(h(1:cluskm+1),textlegend);
            xlabel('Dimension 1'); ylabel('Dimension 2');
            axis equal;
            hold off;
            title('KMEANS : S-index');
            %                 FIG_out = ['../' foldername '/Fig' num2str(cntfigall) '_KMEANS_Cluster_Plot'];
            %                 FIG_out = ['../' foldername '/Figure_KMEANS_Cluster_Plot'];
            FIG_out = [foldername '/Figure_KMEANS_Cluster_Plot'];
            saveas(gcf,FIG_out);
            %                 print('-f','-djpeg','-r300',FIG_out);
            cntfigall = cntfigall+1;

        elseif dimmds2to == 3
            if dimmdsto ~= 2 && dimmdsto ~= 3
                figure(cntfigall); clf(cntfigall);
            else
                subplot(1,2,2);
            end
            hold on;
            toff_x = (max(Smds(:,1))-min(Smds(:,1)))/30;
            toff_y = (max(Smds(:,2))-min(Smds(:,2)))/30;
            toff_z = (max(Smds(:,3))-min(Smds(:,3)))/30;
            h = 0;
            textlegend = {};
            for i = 1:cluskm
                h(i) = plot3(Smds(Idkms==i,1),Smds(Idkms==i,2),Smds(Idkms==i,3),clustercolor{i},'markersize',6,'linewidth',2);
                h(i+cluskm) = plot3(Gkms(i,1),Gkms(i,2),Gkms(i,3),[centroidcolor{ceil(mod(i,5.001))} 'x'],'markersize',10,'linewidth',2);
                plot3(Gkms(i,1),Gkms(i,2),Gkms(i,3),[centroidcolor{ceil(mod(i,5.001))} 'o'],'markersize',10,'linewidth',2);
                text(Smds(Idkms==i,1)+toff_x,Smds(Idkms==i,2)-toff_y,Smds(Idkms==i,3)-toff_z,char(ptid(Idkms==i)),'fontsize',9,'color',...
                    centroidcolor{ceil(mod(i,5.001))});
                textlegend{i} = ['Cluster ' num2str(i)];
            end
            textlegend{i+1} = 'Centroids';
            legend(h(1:cluskm+1),textlegend);
            xlabel('Dimension 1'); ylabel('Dimension 2'); zlabel('Dimension 3');
            box on; grid on;
            view(35,15);
            axis equal;
            hold off;
            title('KMEANS : S-index');
            %                 FIG_out = ['../' foldername '/Fig' num2str(cntfigall) '_KMEANS_Cluster_Plot'];
            %                 FIG_out = ['../' foldername '/Figure_KMEANS_Cluster_Plot'];
            FIG_out = [foldername '/Figure_KMEANS_Cluster_Plot'];
            saveas(gcf,FIG_out);
            %                 print('-f','-djpeg','-r300',FIG_out);
            cntfigall = cntfigall+1;
        end
        fclose(fid_kms);
    else
        flagkm = 0;
        Tinfo = [Tinfokm; Tinfokm2];
        disp(' *** Error in KMEANS *** ');
        disp(Tinfo);
        disp('');
    end

    if gui_active
        h_pbar = progressbar( h_pbar,1/max_count); % update progressbar
    else
        T = {sprintf('\nOperation was aborted by user')} ;
        set(handles.info, 'String',T);    % Show text T (information)
        progressbar( h_pbar,-1 );          % finish progress bar
        break ;
    end
end

%%% Heirarchical Clustering Analysis
Ghc = 0;
c = 0;
I = 0;
Shc = 0;
Sc = 0;
SI = 0;
if flaghc == 1
    switch linkagehc
        case 1
            opt_linkage = 'average';
        case 2
            opt_linkage = 'centroid';
        case 3
            opt_linkage = 'complete';
        case 4
            opt_linkage = 'median';
        case 5
            opt_linkage = 'single';
        case 6
            opt_linkage = 'ward';
        case 7
            opt_linkage = 'weighted';
    end
    switch criterionhc
        case 1
            opt_criterion = 'inconsistent';
        case 2
            opt_criterion = 'distance';
    end
    Gsq = squareform(G);
    type = 1;

    figure(cntfigall); clf(cntfigall);

    if methodthresholdhc == 1   % use max cluster
        [Ghc,c,I,Tinfohc,chkErrorhc] = hca2(1,Gsq,ptid,type,'linkage',opt_linkage,'maxclust',thresholdhc,'criterion',opt_criterion, ...
            'depth',depthhc);
    elseif methodthresholdhc == 2 % use cutoff
        [Ghc,c,I,Tinfohc,chkErrorhc] = hca2(1,Gsq,ptid,type,'linkage',opt_linkage,'cutoff',thresholdhc,'criterion',opt_criterion, ...
            'depth',depthhc);
    end
    %         G = squareform(G);
    Ssq = squareform(S);
    type = 2;
    if methodthresholdhc == 1   % use max cluster
        [Shc,Sc,SI,Tinfohc2,chkErrorhc2] = hca2(2,Ssq,ptid,type,'linkage',opt_linkage,'maxclust',thresholdhc,'criterion',opt_criterion, ...
            'depth',depthhc);
    elseif methodthresholdhc == 2 % use cutoff
        [Shc,Sc,SI,Tinfohc2,chkErrorhc2] = hca2(2,Ssq,ptid,type,'linkage',opt_linkage,'cutoff',thresholdhc,'criterion',opt_criterion, ...
            'depth',depthhc);
    end
    %         S = squareform(S);

    if chkErrorhc == 0 & chkErrorhc2 == 0
        %             FIG_out = ['../' foldername '/Fig' num2str(cntfigall) '_HCA_Dendrogram_Plot'];
        %             FIG_out = ['../' foldername '/Figure_HCA_Dendrogram_Plot'];
        FIG_out = [foldername '/Figure_HCA_Dendrogram_Plot'];
        saveas(gcf,FIG_out);
        %             print('-f','-djpeg','-r300',FIG_out);
        cntfigall = cntfigall+1;
    else
        flaghc = 0;
        %         close(cntfig);
        Tinfo = [Tinfohc; Tinfohc2];
        disp(' *** Error in HCA *** ');
        disp(Tinfo);
        disp('');
    end

    if gui_active
        h_pbar = progressbar( h_pbar,1/max_count); % update progressbar
    else
        T = {sprintf('\nOperation was aborted by user')} ;
        set(handles.info, 'String',T);    % Show text T (information)
        progressbar( h_pbar,-1 );          % finish progress bar
        break ;
    end
end